package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class GetReferenceExample {

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");
        try {
            persistEntity(emf);
            loadEntity(emf);
        } finally {
            emf.close();
        }
    }

    private static Employee persistEntity(EntityManagerFactory emf) {
        Employee employee = new Employee("Sara Dorsey", "Admin");
        System.out.println("-- persisting employee --");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        em.persist(employee);
        em.getTransaction().commit();
        em.close();
        System.out.println("Employee persisted: " + employee);
        return employee;
    }

    private static void loadEntity(EntityManagerFactory emf) {
        System.out.println("-- loading employee by id --");
        EntityManager em = emf.createEntityManager();
        System.out.println("calling getReference().");
        Employee employee = em.getReference(Employee.class, 1);
        System.out.println("getReference() already called");
        System.out.println("loaded employee name: " + employee.getName());
        em.close();
    }
}